HDU 4126 Genghis Khan the Conqueror 最小生成树+树形dp

题目链接:

http://acm.hdu.edu.cn/showproblem.php?pid=4126

Genghis Khan the Conqueror


Time Limit: 10000/5000 MS (Java/Others)Memory Limit: 327680/327680 K (Java/Others)
问题描述

Genghis Khan(成吉思汗)(1162-1227), also known by his birth name Temujin(铁木真) and temple name Taizu(元太祖), was the founder of the Mongol Empire and the greatest conqueror in Chinese history. After uniting many of the nomadic tribes on the Mongolian steppe, Genghis Khan founded a strong cavalry equipped by irony discipline, sabers and powder, and he became to the most fearsome conqueror in the history. He stretched the empire that resulted in the conquest of most of Eurasia. The following figure (origin: Wikipedia) shows the territory of Mongol Empire at that time.
Our story is about Jebei Noyan(哲别), who was one of the most famous generals in Genghis Khan’s cavalry. Once his led the advance troop to invade a country named Pushtuar. The knights rolled up all the cities in Pushtuar rapidly. As Jebei Noyan’s advance troop did not have enough soldiers, the conquest was temporary and vulnerable and he was waiting for the Genghis Khan’s reinforce. At the meantime, Jebei Noyan needed to set up many guarders on the road of the country in order to guarantee that his troop in each city can send and receive messages safely and promptly through those roads.

There were N cities in Pushtuar and there were bidirectional roads connecting cities. If Jebei set up guarders on a road, it was totally safe to deliver messages between the two cities connected by the road. However setting up guarders on different road took different cost based on the distance, road condition and the residual armed power nearby. Jebei had known the cost of setting up guarders on each road. He wanted to guarantee that each two cities can safely deliver messages either directly or indirectly and the total cost was minimal.

Things will always get a little bit harder. As a sophisticated general, Jebei predicted that there would be one uprising happening in the country sooner or later which might increase the cost (setting up guarders) on exactly ONE road. Nevertheless he did not know which road would be affected, but only got the information of some suspicious road cost changes. We assumed that the probability of each suspicious case was the same. Since that after the uprising happened, the plan of guarder setting should be rearranged to achieve the minimal cost, Jebei Noyan wanted to know the new expected minimal total cost immediately based on current information.

输入

There are no more than 20 test cases in the input.
For each test case, the first line contains two integers N and M (1<=N<=3000, 0<=M<=N×N), demonstrating the number of cities and roads in Pushtuar. Cities are numbered from 0 to N-1. In the each of the following M lines, there are three integers xi, yi and ci(ci<=107), showing that there is a bidirectional road between xi and yi, while the cost of setting up guarders on this road is ci. We guarantee that the graph is connected. The total cost of the graph is less or equal to 109.

The next line contains an integer Q (1<=Q<=10000) representing the number of suspicious road cost changes. In the following Q lines, each line contains three integers Xi, Yi and Ci showing that the cost of road (Xi, Yi) may change to Ci (Ci<=107). We guarantee that the road always exists and Ci is larger than the original cost (we guarantee that there is at most one road connecting two cities directly). Please note that the probability of each suspicious road cost change is the same.

输出

For each test case, output a real number demonstrating the expected minimal total cost. The result should be rounded to 4 digits after decimal point.

样例输入

3 3
0 1 3
0 2 2
1 2 5
3
0 2 3
1 2 6
0 1 6
0 0

样例输出

6.0000

题意

给你一个无相图,要你求最小生成树,现在有q个查询,每个查询会改变一条边的权值,然后再改回去,要你求出每种情况下的最小生成树,最后求一下平均。

题解

1、如果改变的边不在我们一开始求的mst上,那么答案就是mst。
2、否则,把指定的树边删了,我们得到两个顶点集,那么代替原先那条边的一定是这两个集合的最短距离。所以我们只要处理出best[u][v](既u所在的集合和v所在的集合的最短距离)就能处理第2种情况了。做法是两次树dp,具体看代码。

dp[u][v]:顶点u到集合v的最短距离。
best[u][v]:集合u到集合v的最短距离。

代码

#include<map>
#include<set>
#include<cmath>
#include<queue>
#include<stack>
#include<ctime>
#include<vector>
#include<cstdio>
#include<string>
#include<bitset>
#include<cstdlib>
#include<cstring>
#include<iostream>
#include<algorithm>
#include<functional>
using namespace std;
#define X first
#define Y second
#define mkp make_pair
#define lson (o<<1)
#define rson ((o<<1)|1)
#define mid (l+(r-l)/2)
#define sz() size()
#define pb(v) push_back(v)
#define all(o) (o).begin(),(o).end()
#define clr(a,v) memset(a,v,sizeof(a))
#define bug(a) cout<<#a<<" = "<<a<<endl
#define rep(i,a,b) for(int i=a;i<(b);i++)
#define scf scanf
#define prf printf

typedef long long LL;
typedef vector<int> VI;
typedef pair<int,int> PII;
typedef vector<pair<int,int> > VPII;

const int INF=0x3f3f3f3f;
const LL INFL=0x3f3f3f3f3f3f3f3fLL;
const double eps=1e-8;
const double PI = acos(-1.0);

//start----------------------------------------------------------------------

const int maxn=3030;

struct Edge {
    int u,v,w;
    Edge(int u,int v,int w):u(u),v(v),w(w) {}
    Edge() {}
    bool operator < (const Edge& tmp) const {
        return w<tmp.w;
    }
} egs[maxn*maxn];

int n,m;
int G[maxn][maxn],dp[maxn][maxn],best[maxn][maxn];
bool used[maxn][maxn];
VPII tre[maxn];

int fa[maxn];
int find(int x) {
    return fa[x]=fa[x]==x?x:find(fa[x]);
}

void dfs(int u,int fa,int rt) {
    if(u!=rt&&!used[u][rt]) dp[rt][u]=min(dp[rt][u],G[rt][u]);
    rep(i,0,tre[u].sz()) {
        int v=tre[u][i].X;
        if(v==fa) continue;
        dfs(v,u,rt);
        dp[rt][u]=min(dp[rt][u],dp[rt][v]);
    }
}

int dfs2(int u,int fa,int rt) {
    if(best[u][rt]<100000000) return best[u][rt];
    best[u][rt]=min(best[u][rt],dp[u][rt]);
    for(int i=0; i<tre[u].sz(); i++) {
        int v=tre[u][i].X;
        if(v==fa) continue;
        dfs2(v,u,rt);
        best[u][rt]=min(best[u][rt],best[v][rt]);
    }
    return best[u][rt];
}

///最小生成树
double kruskal() {
    sort(egs,egs+m);
    double mst=0;
    for(int i=0; i<m; i++) {
        int u=egs[i].u,v=egs[i].v,w=egs[i].w;
        int pu=find(u);
        int pv=find(v);
        if(pu!=pv) {
            fa[pv]=pu;
            tre[u].pb(mkp(v,w));
            tre[v].pb(mkp(u,w));
            used[u][v]=used[v][u]=1;
            mst+=w;
        }
    }
    return mst;
}

void init() {
    clr(G,0x3f);
    clr(dp,0x3f);
    clr(best,0x3f);
    clr(used,0);
    for(int i=0; i<n; i++) fa[i]=i,tre[i].clear();
}

int main() {
    while(scf("%d%d",&n,&m)==2&&n) {
        init();
        for(int i=0; i<m; i++) {
            int u,v,w;
            scf("%d%d%d",&u,&v,&w);
            G[u][v]=G[v][u]=w;
            egs[i]=Edge(u,v,w);
        }

        double mst=kruskal();

        ///树形dp,dp[u][v]表示u到以v为根的子树的最短距离,既点到集合的距离(以u为根开始遍历,且只用非树边更新)
        for(int i=0; i<n; i++) dfs(i,-1,i);

        ///记忆化搜索,best[u][v]表示以u为根的子树和以v为根的子树之间的最短距离,既集合到集合的距离
        ///对于子树v,我们已经求出了所有的点u到它的最短距离,现在只要遍历所有的u,求出最小值即可。
        for(int i=0; i<n; i++) {
            for(int j=0; j<tre[i].sz(); j++) {
                int v=tre[i][j].X;
                best[i][v]=best[v][i]=dfs2(i,v,v);
            }
        }

        int q;
        scf("%d",&q);
        double ans=0;
        rep(i,0,q) {
            int u,v,w;
            scf("%d%d%d",&u,&v,&w);
            if(used[u][v]) {
                ///在树边上
                ans+=mst-G[u][v]+min(w,best[u][v]);
            } else {
                ///不在树边上
                ans+=mst;
            }
        }

        prf("%.4lf\n",ans/q);
    }
    return 0;
}

//end-----------------------------------------------------------------------

转载于:https://www.cnblogs.com/fenice/p/5955496.html

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值